module.exports = { contents: "\"use strict\";\r\nObject.defineProperty(exports, \"__esModule\", { value: true });\r\n/**\r\n * Creates a persistence storage based on the localStorage.\r\n * @returns {PersistenceStrategy}\r\n */\r\nfunction localStorageStrategy() {\r\n    function get(key) {\r\n        return new Promise(function (resolve, reject) {\r\n            var v = localStorage.getItem(key);\r\n            if (v) {\r\n                resolve(JSON.parse(v));\r\n                return;\r\n            }\r\n            reject();\r\n        });\r\n    }\r\n    function put(key, data) {\r\n        return new Promise(function (resolve, reject) {\r\n            localStorage.setItem(key, JSON.stringify(data));\r\n            resolve();\r\n        });\r\n    }\r\n    return {\r\n        get: get,\r\n        put: put\r\n    };\r\n}\r\nexports.localStorageStrategy = localStorageStrategy;\r\n",
dependencies: [],
sourceMap: {},
headerContent: undefined,
mtime: 1494191883000,
devLibsRequired : undefined
};