module.exports = { contents: "\"use strict\";\r\nObject.defineProperty(exports, \"__esModule\", { value: true });\r\n/**\r\n * Creates an object pool to help with object reuse.\r\n * This is to optimise garabage collection in JS application.\r\n * @param {function} make an object generator function. If provided, the function will be called when no the pool is empty.\r\n * @returns {Pool}\r\n */\r\nfunction createPool(make) {\r\n    var pool = [];\r\n    function get(d) {\r\n        if (pool.length === 0) {\r\n            var v = (make && make(d)) || {};\r\n            return v;\r\n        }\r\n        return pool.shift();\r\n    }\r\n    function put(o) {\r\n        pool.push(o);\r\n    }\r\n    return {\r\n        get: get,\r\n        put: put,\r\n    };\r\n}\r\nexports.createPool = createPool;\r\n",
dependencies: [],
sourceMap: {},
headerContent: undefined,
mtime: 1494165363000,
devLibsRequired : undefined
};